<?php

namespace Wappointment\Services;

use Wappointment\Config\Database;
use Wappointment\WP\Helpers as WPHelpers;
use Wappointment\WP\Scheduler as WPScheduler;
use Wappointment\ClassConnect\Capsule;
class Reset
{
    public function __construct()
    {
        do_action('wappointment_reset');
        $this->removeStaffSettings();
        $this->dropTables();
        $this->removeCoreSettings();
        \Wappointment\WP\Scheduler::clearScheduler();
    }
    private function removeStaffSettings()
    {
        foreach (\Wappointment\Services\Staff::getIds() as $staff_id) {
            \Wappointment\Services\Settings::deleteStaff($staff_id);
            \Wappointment\WP\Helpers::deleteStaffOption('availability', $staff_id);
            \Wappointment\WP\Helpers::deleteStaffOption('last-calendar-id', $staff_id);
            \Wappointment\WP\Helpers::deleteStaffOption('last-calendar-checked', $staff_id);
            \Wappointment\WP\Helpers::deleteStaffOption('last-calendar-parsed', $staff_id);
            \Wappointment\WP\Helpers::deleteStaffOption('viewed_updates', $staff_id);
            \Wappointment\WP\Helpers::deleteStaffOption('hello_page', $staff_id);
        }
    }
    private function dropTables()
    {
        $migrate = new \Wappointment\Installation\Migrate();
        $migrate->rollback();
        \Wappointment\ClassConnect\Capsule::schema()->dropIfExists(\Wappointment\Config\Database::$prefix_self . '_migrations');
        if (\Wappointment\ClassConnect\Capsule::schema()->hasTable(\Wappointment\Config\Database::$prefix_self . '_migrations')) {
            throw new \WappointmentException("Error while DROPPING DB tables", 1);
        }
    }
    private function removeCoreSettings()
    {
        \Wappointment\WP\Helpers::deleteOption('wizard_step');
        \Wappointment\WP\Helpers::deleteOption('subscribed_status');
        \Wappointment\WP\Helpers::deleteOption('widget_settings');
        \Wappointment\WP\Helpers::deleteOption('site_details');
        \Wappointment\WP\Helpers::deleteOption('site_key');
        \Wappointment\WP\Helpers::deleteOption('installation_completed');
        \Wappointment\WP\Helpers::deleteOption('installation_step');
        \Wappointment\WP\Helpers::deleteOption('db_version');
        \Wappointment\Services\Settings::delete();
    }
}
