<?php

declare (strict_types=1);
namespace WappoVendor\Achse\Comparable;

trait ComparisonMethods
{
    /**
     * @param IComparable $other
     * @return int (-1, 0, 1)
     */
    public abstract function compare(\WappoVendor\Achse\Comparable\IComparable $other) : int;
    /**
     * @param IComparable $other
     * @return bool
     */
    public function isEqual(\WappoVendor\Achse\Comparable\IComparable $other) : bool
    {
        return $this->compare($other) === 0;
    }
    /**
     * @param IComparable $other
     * @return bool
     */
    public function isLessThan(\WappoVendor\Achse\Comparable\IComparable $other) : bool
    {
        return $this->compare($other) < 0;
    }
    /**
     * @param IComparable $other
     * @return bool
     */
    public function isLessThanOrEqual(\WappoVendor\Achse\Comparable\IComparable $other) : bool
    {
        return $this->compare($other) <= 0;
    }
    /**
     * @param IComparable $other
     * @return bool
     */
    public function isGreaterThan(\WappoVendor\Achse\Comparable\IComparable $other) : bool
    {
        return $this->compare($other) > 0;
    }
    /**
     * @param IComparable $other
     * @return bool
     */
    public function isGreaterThanOrEqual(\WappoVendor\Achse\Comparable\IComparable $other) : bool
    {
        return $this->compare($other) >= 0;
    }
}
