<?php

declare (strict_types=1);
namespace WappoVendor\Achse\Math\Interval\DateTime;

use WappoVendor\Achse\Math\Interval\Boundary;
use WappoVendor\Achse\Math\Interval\Interval;
use WappoVendor\Achse\Math\Interval\IntervalStringParser;
/**
 * @deprecated Use DateTimeImmutable, always!
 */
final class DateTimeIntervalStringParser extends \WappoVendor\Achse\Math\Interval\IntervalStringParser
{
    /**
     * @param string $string
     * @return DateTimeInterval
     */
    public static function parse(string $string) : \WappoVendor\Achse\Math\Interval\Interval
    {
        list($left, $right) = self::parseBoundariesStringsFromString($string);
        return new \WappoVendor\Achse\Math\Interval\DateTime\DateTimeInterval(self::parseBoundary($left), self::parseBoundary($right));
    }
    /**
     * @param string $string
     * @return DateTimeBoundary
     */
    protected static function parseBoundary(string $input) : \WappoVendor\Achse\Math\Interval\Boundary
    {
        list($elementString, $state) = self::parseBoundaryDataFromString($input);
        /** @var DateTime $dateTime */
        $dateTime = \WappoVendor\Achse\Math\Interval\DateTime\DateTime::createFromFormat(\DateTime::ATOM, $elementString);
        return new \WappoVendor\Achse\Math\Interval\DateTime\DateTimeBoundary(\WappoVendor\Achse\Math\Interval\DateTime\DateTime::from($dateTime), $state);
    }
}
