<?php

declare (strict_types=1);
namespace WappoVendor\Achse\Math\Interval\Integer;

use WappoVendor\Achse\Comparable\IComparable;
use WappoVendor\Achse\Math\Interval\Boundary;
use WappoVendor\Achse\Math\Interval\Interval;
final class IntegerInterval extends \WappoVendor\Achse\Math\Interval\Interval
{
    /**
     * @inheritdoc
     */
    public function __construct(\WappoVendor\Achse\Math\Interval\Boundary $left, \WappoVendor\Achse\Math\Interval\Boundary $right)
    {
        $this->validateBoundaryChecks($left, $right, \WappoVendor\Achse\Math\Interval\Integer\IntegerBoundary::class);
        parent::__construct($left, $right);
    }
    /**
     * @return IntegerBoundary
     */
    public function getLeft() : \WappoVendor\Achse\Math\Interval\Boundary
    {
        return parent::getLeft();
    }
    /**
     * @return IntegerBoundary
     */
    public function getRight() : \WappoVendor\Achse\Math\Interval\Boundary
    {
        return parent::getRight();
    }
    /**
     * @param IComparable $element
     * @param bool $state
     * @return IntegerBoundary
     */
    protected function buildBoundary(\WappoVendor\Achse\Comparable\IComparable $element, bool $state) : \WappoVendor\Achse\Math\Interval\Boundary
    {
        return new \WappoVendor\Achse\Math\Interval\Integer\IntegerBoundary($element, $state);
    }
}
