<?php

declare (strict_types=1);
namespace WappoVendor\Achse\Math\Interval\Integer;

use WappoVendor\Achse\Math\Interval\Boundary;
use WappoVendor\Achse\Math\Interval\Interval;
use WappoVendor\Achse\Math\Interval\IntervalStringParser;
final class IntegerIntervalStringParser extends \WappoVendor\Achse\Math\Interval\IntervalStringParser
{
    /**
     * @param string $string
     * @return IntegerInterval
     */
    public static function parse(string $string) : \WappoVendor\Achse\Math\Interval\Interval
    {
        list($left, $right) = self::parseBoundariesStringsFromString($string);
        return new \WappoVendor\Achse\Math\Interval\Integer\IntegerInterval(self::parseBoundary($left), self::parseBoundary($right));
    }
    /**
     * @param string $string
     * @return IntegerBoundary
     */
    protected static function parseBoundary(string $input) : \WappoVendor\Achse\Math\Interval\Boundary
    {
        list($elementString, $state) = self::parseBoundaryDataFromString($input);
        return new \WappoVendor\Achse\Math\Interval\Integer\IntegerBoundary(\WappoVendor\Achse\Math\Interval\Integer\Integer::fromString($elementString), $state);
    }
}
