<?php

namespace WappoVendor\libphonenumber\Leniency;

use WappoVendor\libphonenumber\PhoneNumber;
use WappoVendor\libphonenumber\PhoneNumberMatcher;
use WappoVendor\libphonenumber\PhoneNumberUtil;
class Valid extends \WappoVendor\libphonenumber\Leniency\AbstractLeniency
{
    protected static $level = 2;
    /**
     * Phone numbers accepted are PhoneNumberUtil::isPossibleNumber() and PhoneNumberUtil::isValidNumber().
     * Numbers written in national format must have their national-prefix present if it is usually written
     * for a number of this type.
     *
     * @param PhoneNumber $number
     * @param string $candidate
     * @param PhoneNumberUtil $util
     * @return bool
     */
    public static function verify(\WappoVendor\libphonenumber\PhoneNumber $number, $candidate, \WappoVendor\libphonenumber\PhoneNumberUtil $util)
    {
        if (!$util->isValidNumber($number) || !\WappoVendor\libphonenumber\PhoneNumberMatcher::containsOnlyValidXChars($number, $candidate, $util)) {
            return false;
        }
        return \WappoVendor\libphonenumber\PhoneNumberMatcher::isNationalPrefixPresentIfRequired($number, $util);
    }
}
